"""
Collect GML exceptions here
$Id: Exceptions.py,v 1.4 2000/08/29 12:37:56 konrad Exp $
(C) 2000 Konrad Anton
"""

class GML_Error(Exception):
    errtype="General Error"
    def __init__(self, line, col, msg="fatal error"):
        self.line=line
        self.col=col
        self.strerror="line %d, col %d: %s: %s"%(line,col,self.errtype,msg)
    def __str__(self):
        return self.strerror

class GML_SyntaxError(GML_Error):
    errtype="Syntax error"

class GML_NameError(GML_Error):
    errtype="Name error"

class GML_TypeError(GML_Error):
    errtype="Type error"

class GML_IndexError(GML_Error):
    errtype="Index error"

class GML_StackUnderflowError( GML_Error ) :
    errtype="Stack underflow"

class GML_RuntimeError( GML_Error ) :
    errtype="Runtime Error"

