#!/usr/bin/env python
"""
Test framework
$Id: Test.py,v 1.10 2000/08/29 18:57:41 konrad Exp $
(C) 2000 Konrad Anton
"""
import sys
from Parser import GML_Parser, GML_Lexer
import PrettyPrint
import Stackmachine, Exceptions
import getopt
import Optimizer
import RayTrace
import Ops 
do_optimize=do_verbose=quiet=0

import RayTrace
RayTrace.optionList=sys.argv[2:]

try:
    optlist, args = getopt.getopt( sys.argv[1:], "OvqK"+RayTrace.getopt_args)
    filename = args[0]
    if ('-O','') in optlist:
        do_optimize=1
    if ('-v','') in optlist:
        do_verbose=1
    if ('-q','') in optlist:
        quiet=1
    if ('-K','') in optlist:
        Ops.setExtendedLanguage(0)
##    if ('-g','') in optlist:
##        RayTrace.setDbgRender(1)

    RayTrace.setOptionList(optlist)
        
except getopt.error:
    print """
    GML testing tool
    Test.py [-v] [-O] [-q] [-K] filename
    recognized options:
    -v verbose
    -O optimize
    -q quiet
    -K turn off language extensions
    -i substitute uncomputable pixels with neighbour
    -u same, but ignore more errors
    filename is the GML source to run, or - for stdin
    """
    sys.exit(1)

try:
    if not quiet:
        print "CuttySark GML interpreter and RayTracer"
        print "(C) 2000,  the Cobra Team"
    if filename == '-':
        thefile = sys.stdin
    else:
        thefile=open(filename, "rt")
    if not quiet: print "Parsing...",filename
    pa=GML_Parser(GML_Lexer(thefile))
    prog=pa.getProgram()

    if do_optimize:
        if not quiet: print "Optimizing..."
        opti=Optimizer.Optimizer(verbose=do_verbose)
        (prog, asyms) = opti.run(prog)
    else:
        if not quiet: print "Skipping optimizations..."
    
    sm=Stackmachine.Stackmachine(verbose=do_verbose)
    if not quiet: print "Running..."
    sm.run(prog)
    if not quiet: print "Done."

except Exceptions.GML_Error, e:
    print "Fatal error:\n",str(e)
    sys.exit(1)
# we handle real runtime errors in Ops.Operation.__call__
##except Exception, e:
##    print "Fatal error (python exception):\n",e
##    sys.exit(1)
else:
    sys.exit(0)
